#include "FrustumCullingTraverser.h"
#include "SceneEntity.h"

using namespace std;


namespace CHCDemo
{

FrustumCullingTraverser::FrustumCullingTraverser(): RenderTraverser() 
{
}


void FrustumCullingTraverser::Traverse()
{
	while (!mDistanceQueue.empty())
	{
		BvhNode *node = mDistanceQueue.top();
		mDistanceQueue.pop();
	
		// interesting for the visualization, so rest and set
		node->SetVisible(false);

		if (mBvh->IsWithinViewFrustum(node))
		{
			// update node's visited flag => needed for rendering
			// so set it also here
			//node->SetLastVisited(mFrameID);
			node->SetVisible(true);
			TraverseNode(node);
		}
		else
		{
			mStats.mNumFrustumCulledNodes ++;
		}
	}

	mRenderQueue.Render();
	mRenderQueue.Clear();
}


}