#include "StopAndWaitTraverser.h"
#include "SceneEntity.h"


namespace CHCDemo
{

using namespace std;



StopAndWaitTraverser::StopAndWaitTraverser()
{
}


void StopAndWaitTraverser::Traverse()
{
	while (!mDistanceQueue.empty())
	{
		BvhNode *node = mDistanceQueue.top();
		mDistanceQueue.pop();
	
		// interesting for the visualization
		node->SetVisible(false);


		if (mBvh->IsWithinViewFrustum(node))
		{
			// if intersects near plane assume visible and don't issue test
			if (IntersectsNearPlane(node))
			{
				TraverseNode(node);
			}
			else
			{
				OcclusionQuery *query = IssueOcclusionQuery(node, false);

				int visiblePixels = query->GetQueryResult();

				if (visiblePixels > mVisibilityThreshold)
				{
					//cout<< "visible: " << visiblePixels << endl;
					// update node's visited flag => needed for rendering
					// so set it also here
					//node->SetLastVisited(mFrameID);
					//node->SetVisible(true);
				
					TraverseNode(node);
				}
				else
				{
					++ mStats.mNumQueryCulledNodes;
				}
			}
		}
		else
		{
			++ mStats.mNumFrustumCulledNodes;
		}	
	}
}

}